/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
// TODO remove after LKB-184 worker is in production

var control4Discovery = function (message, resourceLocator) {
    return {
        execute: function (callback) {
            var payload = message.payload;
            var host = payload.host;
            var user = payload.user;
            var password = payload.password;
            var nodesList = payload.nodes;

            var control4Driver = resourceLocator.control4Driver;

            console.info(message.correlationId + ' - Executing command control4Discovery ' + message.payload);

            control4Driver.fullDiscovery(host, user, password, nodesList).then(function (result) {
                callback(JSON.stringify(result));
            }).catch(function (res) {
                callback({
                    error: res.message
                });
            });
        },
        describe: function () {
            return message.correlationId + " - control4Discovery message:" + message.payload.host;
        }
    };
};


module.exports.command = control4Discovery;